// -*- Mode: C++; indent-tabs-mode: nil; tab-width: 2 -*-
/*
 * Copyright (C) 2014 Brandon Schaefer
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Brandon Schaefer <brandontschaefer@gmail.com>
 */

#ifndef BOUNCY_GAME_DATA_H
#define BOUNCY_GAME_DATA_H

#include <sigc++/signal.h>

namespace bouncy_ball
{

class BouncyGameData
{
public:
  BouncyGameData();

  void RightScored() const;
  void LeftScored() const;

  sigc::signal<void> left_scored;
  sigc::signal<void> right_scored;
};

} // namespace bouncy_ball

#endif // BOUNCY_GAME_DATA_H
